/* Legal Notice: (C)2009 Altera Corporation. All rights reserved.  Your */
/* use of Altera Corporation's design tools, logic functions and other */
/* software and tools, and its AMPP partner logic functions, and any */
/* output files any of the foregoing (including device programming or */
/* simulation files), and any associated documentation or information are */
/* expressly subject to the terms and conditions of the Altera Program */
/* License Subscription Agreement or other applicable license agreement, */
/* including, without limitation, that your use is for the sole purpose */
/* of programming logic devices manufactured by Altera and sold by Altera */
/* or its authorized distributors.  Please refer to the applicable */
/* agreement for further details. */

#ifdef CHAC_THIS
#else
#include "io.h"
#include "c2h_accelerator_base_addresses.h"

#include <sys/alt_cache.h>

__inline__ volatile  int  do_dma ( int *  __restrict__  dest_ptr,
                 int *  __restrict__  source_ptr,
                 int length
              )
{
  IOWR_32DIRECT(ACCELERATOR_DMA_TUTOR_DO_DMA_MANAGED_INSTANCE_CPU_INTERFACE0_BASE, (4), (int) (dest_ptr));
  IOWR_32DIRECT(ACCELERATOR_DMA_TUTOR_DO_DMA_MANAGED_INSTANCE_CPU_INTERFACE0_BASE, (8), (int) (source_ptr));
  IOWR_32DIRECT(ACCELERATOR_DMA_TUTOR_DO_DMA_MANAGED_INSTANCE_CPU_INTERFACE0_BASE, (12), (int) (length));
  alt_dcache_flush_all();
  /* Write 1 to address 0 starts the accelerator */
  IOWR_32DIRECT(ACCELERATOR_DMA_TUTOR_DO_DMA_MANAGED_INSTANCE_CPU_INTERFACE0_BASE,(0 * sizeof(int)),1);
  /* Poll. When read from address 0 returns 1, the accelerator is done */
  while(IORD_32DIRECT(ACCELERATOR_DMA_TUTOR_DO_DMA_MANAGED_INSTANCE_CPU_INTERFACE0_BASE,(0 * sizeof(int))) == 0)
  {}
  return (( int )IORD_32DIRECT(ACCELERATOR_DMA_TUTOR_DO_DMA_MANAGED_INSTANCE_CPU_INTERFACE0_BASE,(1*sizeof(int))));
}
#endif /* CHAC_THIS */




